#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <pthread.h>
#include <semaphore.h>
#include <sys/time.h>
#include <sys/types.h>
#include <errno.h>

#include "osa.h"



static struct osa_mutex_type *mymutex=NULL ;


void *mythread_1(void *local_state)
{
  struct timeval tv ;
  int take_result ;

  for(;;)
    {
      tv.tv_sec=8 ;
      tv.tv_usec=0 ;
      take_result=osa_mutex_take_timed(mymutex, &tv) ;
      fprintf(stderr,"mythread_1: osa_mutex_take_timed == %d\n",take_result) ;
      sleep(3) ;
      osa_mutex_give(mymutex) ;
      fprintf(stderr,"mythread_1: gave mutex\n") ;
    }
  return(NULL) ;
}

void *mythread_2(void *local_state)
{
  struct timeval tv ;
  int take_result ;

  for(;;)
    {
      tv.tv_sec=8 ;
      tv.tv_usec=0 ;
      take_result=osa_mutex_take_timed(mymutex, &tv) ;
      fprintf(stderr,"mythread_2: osa_mutex_take_timed == %d\n",take_result) ;
      sleep(5) ;
      osa_mutex_give(mymutex) ;
      fprintf(stderr,"mythread_2: gave mutex\n") ;
    }
  return(NULL) ;
}

int main(int argc, char **argv)
{
  int err ;
  pthread_t pthread1, pthread2 ;
  
  mymutex=osa_mutex_create() ;

#if 1  /* use two pthreads to demonstrate the bug */
  err=pthread_create(&pthread1,NULL,mythread_1,NULL) ;
  err=pthread_create(&pthread2,NULL,mythread_2,NULL) ;

  for(;;)
    sleep(4) ;
#endif

#if 0  /* this doesnt have the deadlock problem */
  if(fork())
    mythread_1(NULL) ;
  else
    mythread_2(NULL) ;
#endif

  return(0) ;
}
